﻿Imports System.Data.Spatial

Public Class Form1


    Private Sub btnCriarDados_Click(sender As Object, e As EventArgs) Handles btnCriarDados.Click
        CriarDados()
    End Sub
    Private Sub btnExibirDados_Click(sender As Object, e As EventArgs) Handles btnExibirDados.Click
        ExibirDados()
    End Sub
    Private Sub CriarDados()

        Using contexto = New HotelContext()

            contexto.Hoteis.Add(New Hotel() With { _
                .Nome = "Hotel Arpoador", _
                .Cidade = "Salvador", _
                .Localizacao = DbGeography.FromText("POINT(-12.983148 -38.521729)") _
            })

            contexto.Hoteis.Add(New Hotel() With { _
                .Nome = "Hotel Sereia do Mar", _
                .Cidade = "Guaruja", _
                .Localizacao = DbGeography.FromText("POINT(-23.926013 -46.300049)") _
            })

            contexto.Hoteis.Add(New Hotel() With { _
                .Nome = "Hotel Nosso Cantinho", _
                .Cidade = "Rio de Janeiro", _
                .Localizacao = DbGeography.FromText("POINT(-22.897683 -43.24585)") _
            })

            contexto.Hoteis.Add(New Hotel() With { _
                .Nome = "Hotel Candeias", _
                .Cidade = "Belo Horizonte", _
                .Localizacao = DbGeography.FromText("POINT(-19.932041 -43.970948)") _
            })

            contexto.Hoteis.Add(New Hotel() With { _
                .Nome = "Hotel America", _
                .Cidade = "Goiânia", _
                .Localizacao = DbGeography.FromText("POINT(-16.678293 -49.288331)") _
            })

            contexto.SaveChanges()
        End Using
    End Sub
    Private Sub ExibirDados()
        Using contexto = New HotelContext()
            Dim locais = From loc In contexto.Hoteis
                             Select loc

            lsbDados.Items.Clear()

            For Each hot In locais
                lsbDados.Items.Add(hot.Nome + " - " + hot.Cidade + " - " + hot.Localizacao.ToString())
            Next
        End Using
    End Sub

    Private Sub btnLocalizar_Click(sender As Object, e As EventArgs) Handles btnLocalizar.Click
        Using contexto = New HotelContext
            Dim coordenadas As String = txtLocalizacao.Text
            Dim minhaLocalizacao = DbGeography.FromText("POINT(" + coordenadas + ")") 'Brasilia

            Dim hotel = (From ht In contexto.Hoteis Order By
                            ht.Localizacao.Distance(minhaLocalizacao) _
                            Select ht).FirstOrDefault

            lblResposta.Text = "O hotel mais perto desta localização é : " + vbCrLf + hotel.Nome + vbCrLf + hotel.Cidade + vbCrLf + hotel.Localizacao.Latitude.ToString + "-" + hotel.Localizacao.Longitude.ToString
        End Using
    End Sub
   
End Class
